libmpdclient: mpd/song.h File Reference

libmpdclient 2.9

- Main Page
- Classes
- Files

- File List
- File Members

Functions
song.h File Reference

MPD client library. More...

Go to the source code of this file.

## Functions
void | mpd_song_free (struct mpd_song *song)
mpd_malloc struct mpd_song * | mpd_song_dup (const struct mpd_song *song)
mpd_pure const char * | mpd_song_get_uri (const struct mpd_song *song)
mpd_pure const char * | mpd_song_get_tag (const struct mpd_song *song, enum mpd_tag_type type, unsigned idx)
mpd_pure unsigned | mpd_song_get_duration (const struct mpd_song *song)
mpd_pure unsigned | mpd_song_get_start (const struct mpd_song *song)
mpd_pure unsigned | mpd_song_get_end (const struct mpd_song *song)
mpd_pure time_t | mpd_song_get_last_modified (const struct mpd_song *song)
void | mpd_song_set_pos (struct mpd_song *song, unsigned pos)
mpd_pure unsigned | mpd_song_get_pos (const struct mpd_song *song)
mpd_pure unsigned | mpd_song_get_id (const struct mpd_song *song)
mpd_pure unsigned | mpd_song_get_prio (const struct mpd_song *song)
mpd_malloc struct mpd_song * | mpd_song_begin (const struct mpd_pair *pair)
bool | mpd_song_feed (struct mpd_song *song, const struct mpd_pair *pair)
mpd_malloc struct mpd_song * | mpd_recv_song (struct mpd_connection *connection)

## Detailed Description

MPD client library.

Do not include this header directly. Use mpd/client.h instead.

Definition in file song.h.

## Function Documentation

void mpd_song_free | ( | struct mpd_song * | song | ) |

Free memory allocated by the mpd_song object.

mpd_malloc struct mpd_song* mpd_song_dup | ( | const struct mpd_song * | song | ) |

Duplicates the specified mpd_song object.

Returns
  the copy, or NULL if out of memory

mpd_pure const char* mpd_song_get_uri | ( | const struct mpd_song * | song | ) |

Returns the URI of the song. This is either a path relative to the MPD music directory (without leading slash), or an URL with a scheme, e.g. a HTTP URL for a radio stream.

mpd_pure const char* mpd_song_get_tag | ( | const struct mpd_song * | song,
|  | enum mpd_tag_type | type,
|  | unsigned | idx
| ) |  |

Queries a tag value.

Parameters

  song | the song object
  type | the tag type
  idx | pass 0 to get the first value for this tag type. This argument may be used to iterate all values, until this function returns NULL

Returns
  the tag value, or NULL if this tag type (or this index) does not exist

mpd_pure unsigned mpd_song_get_duration | ( | const struct mpd_song * | song | ) |

Returns the duration of this song in seconds. 0 means the duration is unknown.

mpd_pure unsigned mpd_song_get_start | ( | const struct mpd_song * | song | ) |

Returns the start of the virtual song within the physical file in seconds.

mpd_pure unsigned mpd_song_get_end | ( | const struct mpd_song * | song | ) |

Returns the end of the virtual song within the physical file in seconds. Zero means that the physical song file is played to the end.

mpd_pure time_t mpd_song_get_last_modified | ( | const struct mpd_song * | song | ) |

Returns
  the POSIX UTC time stamp of the last modification, or 0 if that is unknown

void mpd_song_set_pos | ( | struct mpd_song * | song,
|  | unsigned | pos
| ) |  |

Sets the position within the queue. This value is not used for songs which are not in the queue.

This function is useful when applying the values returned by mpd_recv_queue_change_brief().

mpd_pure unsigned mpd_song_get_pos | ( | const struct mpd_song * | song | ) |

Returns the position of this song in the queue. The value is undefined if you did not obtain this song from the queue.

mpd_pure unsigned mpd_song_get_id | ( | const struct mpd_song * | song | ) |

Returns the id of this song in the playlist. The value is undefined if you did not obtain this song from the queue.

mpd_pure unsigned mpd_song_get_prio | ( | const struct mpd_song * | song | ) |

Returns the priority of this song in the playlist. The value is undefined if you did not obtain this song from the queue.

mpd_malloc struct mpd_song* mpd_song_begin | ( | const struct mpd_pair * | pair | ) |

Begins parsing a new song.

Parameters

  pair | the first pair in this song (name must be "file")

Returns
  the new mpd_entity object, or NULL on error (out of memory, or pair name is not "file")

bool mpd_song_feed | ( | struct mpd_song * | song,
|  | const struct mpd_pair * | pair
| ) |  |

Parses the pair, adding its information to the specified mpd_song object.

Returns
  true if the pair was parsed and added to the song (or if the pair was not understood and ignored), false if this pair is the beginning of the next song

mpd_malloc struct mpd_song* mpd_recv_song | ( | struct mpd_connection * | connection | ) |

Receives the next song from the MPD server.

Returns
  a mpd_song object, or NULL on error or if the song list is finished